<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:kosit="http://www.xoev.de/de/kosit-zubehoer/3_1_0" xmlns:kosit-wsdl-xta="http://www.xoev.de/de/kosit-zubehoer/wsdl-xta/3_1_0" xmlns:xoev="http://www.xoev.de/de/xoev-profil/3_0_2" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" xmlns:kosit-wsdl="http://www.xoev.de/de/kosit-zubehoer/wsdl/3_1_0" xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML" xmlns:wsaw="http://www.w3.org/2006/05/addressing/wsdl" xmlns:wsa="http://www.w3.org/2005/08/addressing" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap12/" xmlns:wspmtom="http://schemas.xmlsoap.org/ws/2004/09/policy/optimizedmimeserialization" xmlns:osci="http://www.osci.eu/ws/2008/05/transport" xmlns:wsp="http://www.w3.org/ns/ws-policy" xmlns:oscimeta="http://www.osci.eu/ws/2014/10/transport" xmlns:wsu="http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-utility-1.0.xsd" xmlns:sp="http://docs.oasis-open.org/ws-sx/ws-securitypolicy/200702" xmlns:s12="http://www.w3.org/2003/05/soap-envelope" xmlns:wsam="http://www.w3.org/2007/05/addressing/metadata" version="2.0" exclude-result-prefixes="xmi xsl kosit kosit-wsdl-xta xoev kosit-wsdl xgen uml">
    <!--  xmlns:log="http://www.xoev.de/de/xgenerator/framework/1/log"     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"   xmlns="http://schemas.xmlsoap.org/wsdl/" xmlns:ns="http://schemas.xmlsoap.org/soap/encoding/" xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/" xmlns:osci="http://www.osci.de/2006/07/wsdl/"  xmlns:tpl="http://www.dvdv.de/dvdv/template/" xmlns:ds="http://www.w3.org/2000/09/xmldsig#" -->
    <xsl:template match="/" mode="kosit:default">
        <xsl:apply-templates select="$xoev:my-xmodel/descendant-or-self::packagedElement[kosit-wsdl:wsdlService(.) and ownedAttribute[uml:is-Port(.)]]" mode="kosit-wsdl-xta:wsdl-generic"/>
    </xsl:template>
    <xsl:template match="packagedElement" mode="kosit-wsdl-xta:wsdl-generic">
        <xsl:variable name="service" select="."/>
        <xsl:call-template name="xgen:result-document">
            <xsl:with-param name="local-path" select="xsd:anyURI(kosit-wsdl:wsdlService(.)/@Dateiname)"/>
            <xsl:with-param name="content">
                <definitions>
                    <xsl:namespace name="xta" select="$xoev:my-xmodel/xoev:xsdXModel(.)/@namespace"/>
                    <xsl:attribute name="targetNamespace" select="$xoev:my-xmodel/xoev:xsdXModel(.)/@namespace"/>
                    <xsl:attribute name="name" select="@name"/>
                    <wsp:Policy wsu:Id="osciCommon">
                        <xsl:text>
      </xsl:text>
                        <xsl:comment>XXXXXX general osci policies XXXXXXXXXX</xsl:comment>
                        <wsp:All>
                            <wsam:Addressing wsp:Optional="false">
                                <wsp:Policy>
                                    <wsam:AnonymousResponses/>
                                </wsp:Policy>
                            </wsam:Addressing>
                            <wspmtom:OptimizedMimeSerialization/>
                        </wsp:All>
                    </wsp:Policy>
                    <wsp:Policy wsu:Id="TransportBindingPolicy">
                        <wsp:ExactlyOne>
                            <wsp:All>
                                <sp:TransportBinding>
                                    <wsp:Policy>
                                        <sp:TransportToken>
                                            <wsp:Policy>
                                                <sp:HttpsToken RequireClientCertificate="true"/>
                                            </wsp:Policy>
                                        </sp:TransportToken>
                                        <sp:AlgorithmSuite>
                                            <wsp:Policy>
                                                <sp:Basic256/>
                                            </wsp:Policy>
                                        </sp:AlgorithmSuite>
                                        <sp:Layout>
                                            <wsp:Policy>
                                                <sp:Lax/>
                                            </wsp:Policy>
                                        </sp:Layout>
                                        <xsl:comment>sp:IncludeTimestamp/</xsl:comment>
                                    </wsp:Policy>
                                </sp:TransportBinding>
                                <xsl:comment>sp:Wss10>
                                    &lt;wsp:Policy>
                                        &lt;sp:MustSupportRefKeyIdentifier/>
                                    &lt;/wsp:Policy>
                                &lt;/sp:Wss10</xsl:comment>
                            </wsp:All>
                        </wsp:ExactlyOne>
                    </wsp:Policy>
                    <xsl:text>
    </xsl:text>
                    <xsl:comment>Datenstrukturen</xsl:comment>
                    <types>
                        <xsd:schema>
                            <xsl:attribute name="targetNamespace" select="$xoev:my-xmodel/xoev:xsdXModel(.)/@namespace"/>
                            <xsl:text>
         </xsl:text>
                            <xsl:comment>Die beiden folgenden Pfade sind im XGenerator-Template festgelegt.</xsl:comment>
                            <xsl:text>
         </xsl:text>
                            <xsl:comment>HINWEIS: Auskommentiert nach Umstellung im Rahmen von CR-2018-02</xsl:comment>
                            <xsd:import namespace="http://www.osci.eu/ws/2014/10/transport" schemaLocation="../xsd/OSCI2_MessageMetaData.xsd"/>
                            <xsd:import namespace="http://www.osci.eu/ws/2008/05/transport" schemaLocation="../xsd/OSCI2.xsd"/>
                            <xsd:include>
                                <xsl:variable name="pfad" select="
                                        if ($xoev:my-xmodel/xoev:xsdXModel(.)/@deployment = 'true') then
                                            concat($xoev:my-xmodel/xoev:xsdXModel(.), '/')
                                        else
                                            '../xsd/'"/>
                                <xsl:attribute name="schemaLocation" select="concat($pfad, 'XTA-Webservice-Globale-Elemente.xsd')"/>
                            </xsd:include>
                            <xsd:include>
                                <xsl:variable name="pfad" select="
                                        if ($xoev:my-xmodel/xoev:xsdXModel(.)/@deployment = 'true') then
                                            concat($xoev:my-xmodel/xoev:xsdXModel(.), '/')
                                        else
                                            '../xsd/'"/>
                                <xsl:attribute name="schemaLocation" select="concat($pfad, 'XTA-Webservice-Exceptions.xsd')"/>
                            </xsd:include>
                        </xsd:schema>
                    </types>
                    <xsl:text>
    </xsl:text>
                    <xsl:comment>Nachrichten</xsl:comment>
                    <xsl:apply-templates select="
                            root()/(descendant::packagedElement, descendant::nestedClassifier)
                            [kosit-wsdl:wsdlMessage(.)[contains(@service, $service/@xmi:id)]]" mode="kosit-wsdl-xta:message">
                        <xsl:sort select="@name"/>
                    </xsl:apply-templates>
                    <xsl:text>
    </xsl:text>
                    <xsl:comment>Interfaces</xsl:comment>
                    <xsl:apply-templates select="
                            $service/ownedAttribute[uml:is-Port(.)]/uml:resolve-type(.)/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlBindingType(.)]
                            /uml:resolve-supplier(.)" mode="kosit-wsdl-xta:portType">
                        <xsl:sort select="@name"/>
                    </xsl:apply-templates>
                    <xsl:text>
    </xsl:text>
                    <xsl:comment>Bindung von Protokoll und Interface</xsl:comment>
                    <xsl:apply-templates select="$service/ownedAttribute[uml:is-Port(.)]/uml:resolve-type(.)" mode="kosit-wsdl-xta:binding">
                        <xsl:sort select="@name"/>
                    </xsl:apply-templates>
                    <xsl:text>
    </xsl:text>
                    <xsl:comment>Endpoints des Services</xsl:comment>
                    <service name="{$service/@name}">
                        <xsl:for-each select="ownedAttribute[uml:is-Port(.)]">
                            <xsl:sort select="@name"/>
                            <port name="{@name}">
                                <xsl:attribute name="binding" select="concat('xta:',uml:resolve-type(.)/@name)"/>
                                <soap:address location="REPLACE_WITH_ACTUAL_URL"/>
                                <wsa:EndpointReference>
                                    <wsa:Address>REPLACE_WITH_ACTUAL_URL</wsa:Address>
                                    <wsa:ReferenceParameters>
                                        <osci:TypeOfBusinessScenario>http://www.xoevxta.de/xta/ws</osci:TypeOfBusinessScenario>
                                    </wsa:ReferenceParameters>
                                </wsa:EndpointReference>
                            </port>
                        </xsl:for-each>
                    </service>
                </definitions>
            </xsl:with-param>
        </xsl:call-template>
    </xsl:template>
    <xsl:template match="packagedElement | nestedClassifier" mode="kosit-wsdl-xta:message">
        <message name="{@name}">
            <xsl:choose>
                <xsl:when test="xoev:xsdGlobalElement(.)">
                    <part name="{@name}">
                        <xsl:attribute name="element" select="xoev:qualified-type-name(., ., true())"/>
                    </part>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="ownedAttribute">
                        <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                        <part>
                            <xsl:attribute name="name" select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            <xsl:attribute name="element" select="xoev:qualified-type-name(uml:resolve-type(.), uml:resolve-type(.), true())"/>
                        </part>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>
        </message>
    </xsl:template>
    <xsl:template match="packagedElement | nestedClassifier" mode="kosit-wsdl-xta:portType">
        <portType name="{@name}">
            <xsl:for-each select="ownedComment/body[. != '']">
                <documentation>
                    <xsl:value-of select="xoev:clean-text(.)"/>
                </documentation>
            </xsl:for-each>
            <xsl:apply-templates select="ownedOperation" mode="kosit-wsdl-xta:operation">
                <xsl:sort select="@name"/>
            </xsl:apply-templates>
        </portType>
    </xsl:template>
    <xsl:template match="ownedOperation" mode="kosit-wsdl-xta:operation">
        <operation name="{@name}">
            <xsl:for-each select="ownedComment/body[. != '']">
                <documentation>
                    <xsl:value-of select="xoev:clean-text(.)"/>
                </documentation>
            </xsl:for-each>
            <input>
                <xsl:variable name="in" select="ownedParameter[@direction = 'in']"/>
                <xsl:attribute name="message" select="concat('xta:', $in/uml:resolve-type(.)/@name)"/>
                <xsl:for-each select="$in/ownedComment/body[. != '']">
                    <documentation>
                        <xsl:value-of select="xoev:clean-text(.)"/>
                    </documentation>
                </xsl:for-each>
            </input>
            <output>
                <xsl:variable name="return" select="ownedParameter[@direction = 'return']"/>
                <xsl:attribute name="message" select="concat('xta:', $return/uml:resolve-type(.)/@name)"/>
                <xsl:for-each select="$return/ownedComment/body[. != '']">
                    <documentation>
                        <xsl:value-of select="xoev:clean-text(.)"/>
                    </documentation>
                </xsl:for-each>
            </output>
            <xsl:for-each select="xoev:ids-to-elements(tokenize(@raisedException, ' '), $xoev:my-xmodel)">
                <xsl:sort select="@name"/>
                <fault name="{@name}">
                    <xsl:attribute name="message" select="concat('xta:', @name)"/>
                    <xsl:for-each select="ownedComment/body[. != '']">
                        <documentation>
                            <xsl:value-of select="xoev:clean-text(.)"/>
                        </documentation>
                    </xsl:for-each>
                </fault>
            </xsl:for-each>
        </operation>
    </xsl:template>
    <xsl:template match="packagedElement | nestedClassifier" mode="kosit-wsdl-xta:binding">
        <binding name="{@name}">
            <xsl:variable name="binding" select="."/>
            <xsl:variable name="binding-type" select="xoev:dependencies-by-client(.)[kosit-wsdl:wsdlBindingType(.)]/uml:resolve-supplier(.)"/>
            <xsl:attribute name="type" select="concat('xta:', $binding-type/@name)"/>
            <xsl:for-each select="ownedComment/body[. != '']">
                <documentation>
                    <xsl:value-of select="xoev:clean-text(.)"/>
                </documentation>
            </xsl:for-each>
            <soap:binding style="document" transport="http://schemas.xmlsoap.org/soap/http"/>
            <wsp:PolicyReference URI="#TransportBindingPolicy"/>
            <wsp:PolicyReference URI="#osciCommon"/>
            <xsl:for-each select="$binding-type/ownedOperation">
                <xsl:sort select="@name"/>
                <xsl:variable name="operation" select="."/>
                <operation name="{@name}">
                    <soap:operation soapActionRequired="true">
                        <xsl:attribute name="soapAction" select="concat($binding-type/kosit-wsdl:wsdlPortType(.)/@soapActionBase, kosit-wsdl:wsdlOperation(.)/@soapAction)"/>
                        <xsl:if test="$binding-type/kosit-wsdl:wsdlPortType(.)/@operationDocumentStyle = 'true'">
                            <xsl:attribute name="style">document</xsl:attribute>
                        </xsl:if>
                    </soap:operation>
                    <input>
                        <xsl:for-each select="$binding/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationInputHeaderPart(.)]/uml:resolve-supplier(.)">
                            <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            <soap:header use="literal">
                                <xsl:attribute name="message" select="concat('xta:', parent::*/@name)"/>
                                <xsl:attribute name="part" select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            </soap:header>
                        </xsl:for-each>
                        <xsl:for-each select="$operation/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationInputHeaderPart(.)]/uml:resolve-supplier(.)">
                            <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            <soap:header use="literal">
                                <xsl:attribute name="message" select="concat('xta:', parent::*/@name)"/>
                                <xsl:attribute name="part" select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            </soap:header>
                        </xsl:for-each>
                        <soap:body use="literal"/>
                    </input>
                    <output>
                        <xsl:for-each select="$binding/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationOutputHeaderPart(.)]/uml:resolve-supplier(.)">
                            <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            <soap:header use="literal">
                                <xsl:attribute name="message" select="concat('xta:', parent::*/@name)"/>
                                <xsl:attribute name="part" select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            </soap:header>
                        </xsl:for-each>
                        <xsl:for-each select="$operation/xoev:dependencies-by-client(.)[kosit-wsdl:wsdlOperationOutputHeaderPart(.)]/uml:resolve-supplier(.)">
                            <xsl:sort select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            <soap:header use="literal">
                                <xsl:attribute name="message" select="concat('xta:', parent::*/@name)"/>
                                <xsl:attribute name="part" select="(@name[. != ''], uml:resolve-type(.)/@name)[1]"/>
                            </soap:header>
                        </xsl:for-each>
                        <soap:body use="literal"/>
                    </output>
                    <xsl:for-each select="$operation/xoev:ids-to-elements(tokenize(@raisedException, ' '), $xoev:my-xmodel)">
                        <xsl:sort select="@name"/>
                        <fault name="{@name}">
                            <soap:fault name="{@name}" use="literal"/>
                        </fault>
                    </xsl:for-each>
                </operation>
            </xsl:for-each>
        </binding>
    </xsl:template>
</xsl:stylesheet>
